% Demo Plus-minus Average

% close all prior figures
close all;

% Define Basic parameters
F0 = 3;                     % Fundamental Freq
Ampl = 1;                   % amplitude
Samples = 100;              % Number samples
num_iterations = 1002;       % Number iterations
t   = [(1/Samples):(1/Samples):1];    % independent (time) variable
db_reduction = -10;          % for 1/f amplitude at base signal
y_axis_limits = [db_reduction/2 (-1*db_reduction)/2];
signal_with_noise = zeros([num_iterations,Samples]); % create signal
plus_average = zeros([1,Samples]);
pause_iterations = [2, 22, 42, 62, 82, 102, 162, 242, 482, 722, 962, 1002];

signal = Ampl*sin(2*pi*F0*t);   % Create signal
subplot(2,3,1);                 % Plot signal
plot(signal);
ylim(y_axis_limits);
title('Signal');
subplot(2,3,2);
subplot(2,3,4);
subplot(2,3,5);
pause;

for iteration = 1:num_iterations 
    [phase_param noise_wave]=phase_noise(Samples, F0, db_reduction);  
    if mod(iteration,50) == 0
        subplot(2,3,3);
        title('Twenty Noise Trials');
        hold;
        plot(noise_wave);
        ylim(y_axis_limits);
        hold;
    end
    signal_with_noise(iteration, :)  = signal + noise_wave;
    if iteration == 2
        subplot(2,3,2);
        plot(noise_wave);
        title('Single Noise Trial');
        ylim(y_axis_limits);
        pause;
    end
end
pause; % to show 20 noise trials

for iteration = 2:20:num_iterations
    plus_average = sum(signal_with_noise(1:iteration, :))/iteration;
    plus_minus_average = zeros([1,Samples]);
    for plus_minus_iteration = 2:2:iteration
        plus_minus_average =  plus_minus_average + (signal_with_noise(plus_minus_iteration, :) - signal_with_noise(plus_minus_iteration-1,:));
    end
    plus_minus_average = plus_minus_average/iteration;
    subplot(2,3,4);
    plot(plus_average);
    title('Average');
    ylim(y_axis_limits);
    subplot(2,3,5);
    plot(plus_minus_average);
    title('+/- Average');
    ylim(y_axis_limits);
    subplot(2,3,6);
    bar(iteration);
    title(['# trials = ' num2str(iteration)]);
    ylim([0 1000]);
    if sum(pause_iterations == iteration) == 1 
        pause;
    end
end


